
goog.require('Blockly.Variables');
goog.require('Blockly.JavaScript');
goog.require('Blockly.Procedures');

//// App Blocks

Blockly.Blocks['app_onstart'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(0x1E90FF);
    this.appendDummyInput()
        .appendField("OnStart");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setTooltip('Called when application is started');
  }
};

Blockly.Blocks['app_showpopup'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.ShowPopup");
    this.appendValueInput("message")
        .setCheck("String");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['app_playsound'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.PlaySound");
    this.appendValueInput("file")
        .setCheck("String");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['app_texttospeech'] = {
  init: function() {
    this.setColour(180);
    this.appendValueInput("text")
        .setCheck("String")
        .appendField("app.TextToSpeech");
    this.appendValueInput("pitch")
        .setCheck("Number")
        .appendField("pitch");
    this.appendValueInput("speed")
        .setCheck("Number")
        .appendField("speed");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
    this.setHelpUrl('http://www.example.com/');
  }
};

Blockly.Blocks['app_explode'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("Explode");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

//// Layout Blocks

Blockly.Blocks['app_createlayout'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateLayout")
        .appendField(new Blockly.FieldDropdown([["Linear", "Linear"], ["Absolute", "Absolute"], ["Frame", "Frame"]]), "type");
    this.appendValueInput("options")
        .appendField("options")
        .setCheck(["String", "null"]);
    this.setInputsInline(true);
    this.setOutput(true, "Layout");
    this.setTooltip('');
  }
};

Blockly.Blocks['app_addlayout'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("lay")
        .appendField("app.AddLayout");
    //this.appendDummyInput()
    //    .appendField("to app");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['lay_flow'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("flow")
        .setCheck(["String", "null"])
        .appendField(new Blockly.FieldDropdown([["Vertical", "Vertical"], ["Horizontal", "Horizontal"]]), "flow");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

Blockly.Blocks['lay_layout'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("layout")
        .setCheck(["String", "null"])
        .appendField(new Blockly.FieldDropdown([["Wrap", "Wrap"], ["FillX", "FillX"], ["FillY", "FillY"], ["FillXY", "FillXY"]]), "layout");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

Blockly.Blocks['lay_align'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("align")
        .setCheck(["String", "null"])
        .appendField(new Blockly.FieldDropdown([["VCenter", "VCenter"], ["Center", "Center"], ["Top", "Top"], ["Bottom", "Bottom"], ["Left", "Left"], ["Right", "Right"]]), "align");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

Blockly.Blocks['lay_touchthrough'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("touchthrough")
        .appendField("TouchThrough");
    this.setOutput(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['lay_childaction'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("lay")
        //.appendField("with");
	this.appendDummyInput().appendField(".")
    this.appendDummyInput()
        .appendField(new Blockly.FieldDropdown([["AddChild", "AddChild"], ["RemoveChild", "RemoveChild"], ["DestroyChild", "DestroyChild"]]), "lay_action");
    this.appendValueInput("control");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['lay_settouchable'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        //.appendField("with")
        .appendField(new Blockly.FieldVariable("lay"), "lay")
        .appendField(".SetTouchable");
    this.appendDummyInput()
        .appendField(new Blockly.FieldCheckbox("TRUE"), "touchable");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  },
  getVars: function() {
    return [this.getFieldValue('lay'),this.getFieldValue('touchable')];
  },
  renameVar: function(oldName, newName) {
    if (Blockly.Names.equals(oldName, this.getFieldValue('lay'))) {
      this.setFieldValue(newName, 'lay');
    }
  }
};

//// Image Blocks

Blockly.Blocks['app_createimage'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateImage");
    this.appendValueInput("file")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.setInputsInline(true);
    this.setOutput(true);
    this.setTooltip('');
  }
};

function imageOnTouchOptions() 
{
    function isImageOnTouchFunction(func)
    {
        var params = func[1];
        if(params != null && params.length == 2)
        {
            return (params[0] == "touchX" && params[1] == "touchY");
        }

        return false;
    }

    var functionList = [];

    var workspace = Blockly.getMainWorkspace();
    var allFunctions = Blockly.Procedures.allProcedures(workspace);

    var noReturnFunctions = allFunctions[0];

    if(noReturnFunctions.length > 0)
    {
        for(var f = 0; f < noReturnFunctions.length; ++f)
        {
            console.log(noReturnFunctions[f]);
            functionList.push(noReturnFunctions[f][0]);
        }
    }

    functionList.splice(0, 0, "nothing");

    // Functions are not language-specific, use the name as both the user-facing
    // text and the internal representation.
    var options = [];
    for (var x = 0; x < functionList.length; x++) 
    {
        options[x] = [functionList[x], functionList[x]];
    }
    return options;
}

Blockly.Blocks['img_rotate'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("img")
        //.appendField("rotate");
    this.appendValueInput("angle")
        .setCheck(["Number", "null"])
        .appendField(".Rotate");
    this.appendDummyInput()
        .appendField("");
    this.appendValueInput("centerx")
        .setCheck(["Number", "null"])
        .appendField("X");
    this.appendValueInput("centery")
        .setCheck(["Number", "null"])
        .appendField("Y");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['img_scale'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("img")
        //.appendField("scale");
    this.appendValueInput("scalex")
        .setCheck(["Number", "null"])
        .appendField(".Scale  X");
    this.appendValueInput("scaley")
        .setCheck(["Number", "null"])
        .appendField("Y");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['img_move'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("img")
        //.appendField("move");
    this.appendValueInput("movex")
        .setCheck(["Number", "null"])
        .appendField(".Move  X");
    this.appendValueInput("movey")
        .setCheck(["Number", "null"])
        .appendField("Y");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['img_spin'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("img")
        .appendField("spin");
    this.appendValueInput("time")
        .setCheck(["Number", "null"])
        .appendField("for");
    this.appendDummyInput()
        .appendField("seconds");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['img_ontouchdownevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("img")
        //.appendField("when image");
    this.appendDummyInput()
        .appendField("OnTouchDown : touchX, touchY");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'img', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'img' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouchDown", this);
      return procName;
  },
  getVars: function() {
    return ["touchX", "touchY"];
  }
};

Blockly.Blocks['img_ontouchupevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("img")
        //.appendField("when image");
    this.appendDummyInput()
        .appendField("OnTouchUp : touchX, touchY");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'img', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'img' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouchUp", this);
      return procName;
  },
  getVars: function() {
    return ["touchX", "touchY"];
  }
};

Blockly.Blocks['img_ontouchmoveevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("img")
        //.appendField("when image");
    this.appendDummyInput()
        .appendField("OnTouchMove : touchX, touchY");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'img', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'img' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouchMove", this);
      return procName;
  },
  getVars: function() {
    return ["touchX", "touchY"];
  }
};

//// Text Blocks

Blockly.Blocks['app_createtext'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateText");
    this.appendValueInput("text")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Txt");
    this.setTooltip('');
  }
};

Blockly.Blocks['app_createtextedit'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateTextEdit");
    this.appendValueInput("text")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Txe");
    this.setTooltip('');
  }
};

Blockly.Blocks['txt_align'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("align")
        .setCheck(["String", "null"])
        .appendField(new Blockly.FieldDropdown([["Center", "Center"], ["Left", "Left"], ["Right", "Right"]]), "align");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

Blockly.Blocks['txt_multiline'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("NAME")
        .appendField("MultiLine");
    this.setOutput(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['txt_settextsize'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("txt")
        //.appendField("with");
    this.appendValueInput("size")
        .setCheck(["Number", "null"])
        .appendField(".SetTextSize");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['txt_settextcolor'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("txt")
        //.appendField("with");
    this.appendValueInput("col")
        .appendField(".SetColor");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['edit_gettext'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("edit")
        //.appendField("with");
    this.appendDummyInput()
        .appendField(".GetText");
    this.setInputsInline(true);
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

//// Button Blocks

Blockly.Blocks['app_createbutton'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateButton");
    this.appendValueInput("text")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Btn");
    this.setTooltip('');
  }
};

Blockly.Blocks['btn_style'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("style")
        .setCheck(["String", "null"])
        .appendField(new Blockly.FieldDropdown([["Normal", "Normal"], ["Gray", "Gray"], ["Aluminium", "Aluminium"], ["Lego", "Lego"]]), "style");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

Blockly.Blocks['btn_ontouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("btn")
       // .appendField("OnButton");
    this.appendDummyInput()
        .appendField("OnTouch");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'btn', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'btn' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouch", this);
      return procName;
  }
};

//// Toggle Button Blocks

Blockly.Blocks['app_createtoggle'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateToggle");
    this.appendValueInput("text")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Tgl");
    this.setTooltip('');
  }
};

Blockly.Blocks['tgl_ontouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("tgl")
        //.appendField("when toggle")
        .setCheck("Tgl");
    this.appendDummyInput()
        .appendField("OnTouch : isChecked");
    this.appendStatementInput("statements")
       // .appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'tgl', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'tgl' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouch", this);
      return procName;
  },
  getVars: function() {
    return ["isChecked"];
  }
};

//// Check Box Blocks

Blockly.Blocks['app_createcheckbox'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateCheckbox");
    this.appendValueInput("text")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Chk");
    this.setTooltip('');
  }
};

Blockly.Blocks['chk_ontouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("chk")
        //.appendField("when checkbox")
        .setCheck("Chk");
    this.appendDummyInput()
        .appendField("OnTouch : isChecked");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'chk', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'chk' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouch", this);
      return procName;
  },
  getVars: function() {
    return ["isChecked"];
  }
};

//// Spinner Blocks

Blockly.Blocks['app_createspinner'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateSpinner");
    this.appendValueInput("list")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Spn");
    this.setTooltip('');
  }
};

Blockly.Blocks['spn_ontouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("spn")
        //.appendField("when spinner")
        .setCheck("Spn");
    this.appendDummyInput()
        .appendField("OnTouch : item");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'spn', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'spn' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouch", this);
      return procName;
  },
  getVars: function() {
    return ["item"];
  }
};

//// List Blocks

Blockly.Blocks['app_createlist'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateList");
    this.appendValueInput("list")
        .setCheck(["String", "null"]);
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Lst");
    this.setTooltip('');
  }
};

Blockly.Blocks['lst_ontouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("lst")
        //.appendField("when list")
        .setCheck("Lst");
    this.appendDummyInput()
        .appendField("OnTouch : title, body, type, index");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'lst', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'lst' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouch", this);
      return procName;
  },
  getVars: function() {
    return ["title", "body", "type", "index"];
  }
};

Blockly.Blocks['lst_onlongtouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("lst")
        //.appendField("when list")
        .setCheck("Lst");
    this.appendDummyInput()
        .appendField("OnLongTouch : title, body, type, index");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'lst', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'lst' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnLongTouch", this);
      return procName;
  },
  getVars: function() {
    return ["title", "body", "type", "index"];
  }
};

//// Camera Blocks

Blockly.Blocks['app_createcamera'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateCamera");
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Cam");
    this.setTooltip('');
  }
};

Blockly.Blocks['cam_startpreview'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("cam")
        //.appendField("with");
    this.appendDummyInput()
        .appendField(".StartPreview");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

//// Seekbar Blocks

Blockly.Blocks['app_createseekbar'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateSeekbar");
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Skb");
    this.setTooltip('');
  }
};

Blockly.Blocks['skb_ontouchevent'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendValueInput("skb")
        //.appendField("when seekbar");
    this.appendDummyInput()
        .appendField("OnTouch : value");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setInputsInline(true);
    this.setTooltip('');
  },
  getControl: function() {
      return Blockly.JavaScript.valueToCode(this, 'skb', Blockly.JavaScript.ORDER_ATOMIC);
  },
  getProcedureName: function() {
      // Create the function name from the 'skb' input (removing any illegal characters)
      var procPrefix = this.getControl().replace(/[^\w\s]/gi, "");
      var procName = Blockly.Procedures.findLegalName(procPrefix + "_OnTouch", this);
      return procName;
  },
  getVars: function() {
    return ["value"];
  }
};

//// Control Blocks

Blockly.Blocks['control_setmargins'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("control")
        //.appendField("with");
    this.appendDummyInput()
        .appendField(".SetMargins");
    this.appendValueInput("left")
        .setCheck(["Number", "null"])
        .appendField("left");
    this.appendValueInput("top")
        .setCheck(["Number", "null"])
        .appendField("top");
    this.appendValueInput("right")
        .setCheck(["Number", "null"])
        .appendField("right");
    this.appendValueInput("bottom")
        .setCheck(["Number", "null"])
        .appendField("bottom");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

//// Math Blocks

Blockly.Blocks['math_atan2'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(230);
    this.appendDummyInput()
        .appendField("atan2");
    this.appendValueInput("y")
        .setCheck("Number")
        .appendField("y");
    this.appendValueInput("x")
        .setCheck("Number")
        .appendField("x");
    this.setInputsInline(true);
    this.setOutput(true);
    this.setTooltip('');
  }
};

//// Media Blocks

Blockly.Blocks['image'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(160);

    var imageFileInput = new Blockly.FieldTextInput("/Sys/Img/Hello World.png");
	
	/*
    imageFileInput.showEditorDefault = imageFileInput.showEditor_;
    
    imageFileInput.showEditor_ = function(opt_quietInput) {
      if(this.showImageBrowser)
      {
        this.showImageBrowser();
      }
      else
      {
        this.showEditorDefault(opt_quietInput);
      }
    }
	*/

    this.appendDummyInput()
        .appendField(new Blockly.FieldImage(this.workspace.options.pathToMedia + "image.png", 16, 16, "*"))
        .appendField(imageFileInput, "file");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

Blockly.Blocks['sound'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(160);

    var soundFileInput = new Blockly.FieldTextInput("/Sys/Snd/poing.ogg");
	
	/*
    soundFileInput.showEditorDefault = soundFileInput.showEditor_;
    
    soundFileInput.showEditor_ = function(opt_quietInput) {
      if(this.showSoundBrowser)
      {
        this.showSoundBrowser();
      }
      else
      {
        this.showEditorDefault(opt_quietInput);
      }
    }
	*/

    this.appendDummyInput()
        .appendField(new Blockly.FieldImage(this.workspace.options.pathToMedia + "sound.png", 16, 16, "*"))
        .appendField(soundFileInput, "file");
    this.setOutput(true, "String");
    this.setTooltip('');
  }
};

//// Timing Event Blocks

Blockly.Blocks['do_every'] = {
  init: function() {
    this.setColour(180);
    this.appendValueInput("time")
        .setCheck("Number")
        .appendField("setInterval");
    this.appendDummyInput()
        .appendField("ms");
    this.appendStatementInput("do")
        //.appendField("do");
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setInputsInline(true);
    this.setTooltip('');
    this.setHelpUrl('http://www.example.com/');
  }
};

Blockly.Blocks['do_after'] = {
  init: function() {
    this.setColour(180);
    this.appendValueInput("time")
        .setCheck("Number")
        .appendField("setTimeout");
    this.appendDummyInput()
        .appendField("ms");
    this.appendStatementInput("do")
        //.appendField("do");
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setInputsInline(true);
    this.setTooltip('');
    this.setHelpUrl('http://www.example.com/');
  }
};

Blockly.Blocks['js_code'] = {
  init: function() {
    this.setColour(180);

	 /*
    var codeInput = new Blockly.FieldTextInput("alert('Hi')");
	codeInput.showEditorDefault = codeInput.showEditor_;
    
    codeInput.showEditor_ = function(opt_quietInput) {
      if(this.showCodeEditor)
      {
        this.showCodeEditor();
      }
      else
      {
        this.showEditorDefault(opt_quietInput);
      }
    }

    this.appendDummyInput()
        .appendField(codeInput, "code");
	*/
	
	//this.appendDummyInput().appendField("call");
    //this.appendValueInput(new Blockly.FieldTextInput("alert('Hi')"))//.setCheck("String");
	
	this.appendDummyInput()
		.appendField("code")
		.appendField(new Blockly.FieldTextInput(""), "code")
		
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
    this.setHelpUrl('http://www.example.com/');
  }
};


Blockly.Blocks['js_script'] = {
  init: function() {
    this.setColour(180);

	this.appendDummyInput()
		.appendField("app.Script")
		.appendField(new Blockly.FieldTextInput(""), "file")
		
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
    this.setHelpUrl('http://www.example.com/');
  }
};


//// NXT BLOCKS

Blockly.Blocks['app_createnxt'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateNXT");
    this.setOutput(true);
    this.setTooltip('');
  }
};

// Blockly.Blocks['app_createnxt'] = {
//   init: function() {
//     this.setHelpUrl('http://www.example.com/');
//     this.setColour(180);
//     this.appendDummyInput()
//         .appendField("connect to NXT and call");
//     this.appendValueInput("nxt");
//     this.setInputsInline(true);
//     this.setOutput(true);
//     this.setTooltip('');
//   }
// };

Blockly.Blocks['nxt_connect'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("nxt")
        //.appendField("connect");
	this.appendDummyInput()
         .appendField(".Connect");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['nxt_beep'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("nxt")
        //.appendField("beep");
    this.appendValueInput("frequency")
        .setCheck("Number")
        .appendField(".Beep  frequency");
    this.appendDummyInput()
        .appendField("Hz");
    this.appendValueInput("time")
        .setCheck("Number")
        .appendField("for");
    this.appendDummyInput()
        .appendField("seconds");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['nxt_drive'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("nxt")
        //.appendField("drive");
    this.appendValueInput("motors")
        .setCheck("String")
        .appendField(".Drive  motors");
    this.appendValueInput("power")
        .setCheck("Number")
        .appendField("power");
    this.appendValueInput("rotations")
        .setCheck("Number")
        .appendField("rotate");
    this.appendDummyInput()
        .appendField("times");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

// Drive without specifying rotations
Blockly.Blocks['nxt_drivecontinuous'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("nxt")
        //.appendField("drive");
    this.appendValueInput("motors")
        .setCheck("String")
        .appendField(".Drive  motors");
    this.appendValueInput("power")
        .setCheck("Number")
        .appendField("power");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['nxt_stop'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("nxt")
        //.appendField("stop");
    this.appendValueInput("motors")
        .setCheck("String")
        .appendField(".Stop  motors");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

//// GAME BLOCKS


Blockly.Blocks['app_creategameview'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendDummyInput()
        .appendField("app.CreateGameView");
    this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
    this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Gam");
    this.setTooltip('');
  }
};

Blockly.Blocks['gam_setfile'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gam")
        //.appendField("with");
    this.appendValueInput("file")
        .setCheck(["String", "null"])
        .appendField(".SetFile");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

//// WEBGL BLOCKS

Blockly.Blocks['gfx_onload'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendDummyInput()
        .appendField("OnLoad");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setTooltip('Called to load game assets');
  }
};

Blockly.Blocks['gfx_onready'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendDummyInput()
        .appendField("OnReady");
    this.appendStatementInput("statements")
        //.appendField("do");
    this.setTooltip('Called when game assets have been loaded');
  }
};

Blockly.Blocks['gfx_onanimate'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(290);
    this.appendDummyInput()
        .appendField("OnAnimate");
    this.appendStatementInput("statements")
    this.setTooltip('Called to draw and move game graphics');
  }
};

Blockly.Blocks['gfx_addphysics'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gfx")
        //.appendField("with");
    this.appendValueInput("gravity")
        .setCheck(["Number", "null"])
        .appendField(".AddPhysics")
		.appendField("gravity");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_enclose'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gfx")
        //.appendField("with");
    this.appendValueInput("groupid")
        .setCheck(["Number", "-1"])
        .appendField(".Enclose")
		.appendField("groupid");
	this.appendValueInput("options")
        .setCheck(["String", "null"])
		.appendField("options");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_createbackground'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
	this.appendValueInput("gfx");
    this.appendDummyInput()
        .appendField(".CreateBackground");
    this.appendValueInput("file")
        .setCheck(["String", "null"])
    this.appendValueInput("options")
        .setCheck(["String", "null"])
        .appendField("options");
    this.setInputsInline(true);
    this.setOutput(true, "Tile");
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_createsprite'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
	this.appendValueInput("gfx");
    this.appendDummyInput()
        .appendField(".CreateSprite");
    this.appendValueInput("file")
        .setCheck(["String", "null"])
    this.appendValueInput("group")
        .setCheck(["String", "null"])
        .appendField("group");
    this.setInputsInline(true);
    this.setOutput(true, "Sprite");
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_addbackground'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gfx")
    this.appendDummyInput()
        .appendField(".AddBackground");
    this.appendValueInput("sprite")
        .setCheck(["Tile", "null"])
		.appendField("sprite");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_addsprite'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gfx")
    this.appendDummyInput()
        .appendField(".AddSprite");
    this.appendValueInput("sprite")
        .setCheck(["Sprite", "null"])
		.appendField("sprite");
	this.appendValueInput("x")
        .setCheck(["Number", "0.1"])
        .appendField("x");
	this.appendValueInput("y")
        .setCheck(["Number", "0.1"])
        .appendField("y");
	this.appendValueInput("width")
        .setCheck(["Number", "null"])
        .appendField("width");
	this.appendValueInput("height")
        .setCheck(["Number", "null"])
        .appendField("height");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_play'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gfx")
    this.appendDummyInput()
        .appendField(".Play");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};

Blockly.Blocks['gfx_pause'] = {
  init: function() {
    this.setHelpUrl('http://www.example.com/');
    this.setColour(180);
    this.appendValueInput("gfx")
    this.appendDummyInput()
        .appendField(".Pause");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('');
  }
};




