
function blockly_CreateEditor() 
{
	id = getURLParameter("id");
	
	// Check for presence of readonly=true in the url
	var readOnly = getURLParameter("readonly");
	
	/*
	console.log( "Blockly init" );
	Blockly.inject(document.getElementById("blocklyEditor"), {
			toolbox: document.getElementById('toolbox'),
			readOnly: readOnly,
			scrollbars: true,
			media: "dsj/blockly/media/",
			comments: false, // don't show 'Add Comment' in context menu
			disable: false, // don't show 'Disable Block' in context menu
			zoom: { enabled: true }
		});
		*/
	
	var blocklyEditor = new BlocklyEditor;
    blocklyEditor.init(document.getElementById("blocklyEditor"), !1);
	
	//Handle changes to blockly.
    blocklyEditor.addChangeListener(function() 
	{
		console.log( "synching blockly" )
		
		var dsApp = client.appService.getOpenApp();
		if( dsApp ) 
		{
			//Get JavaScript to hidden ace editor file.
            var f = blockly_syncData( blocklyEditor, true )
        
			//Update redo/undo history.
			if(!blockly_history.locked) 
			{
				Blockly.JavaScript.INFINITE_LOOP_TRAP = null;
				//var dom = Blockly.Xml.workspaceToDom(blocklyEditor.getWorkspace()); //Blockly.Xml.workspaceToDom(Blockly.getMainWorkspace());
				var xml = f.workspace; //Blockly.Xml.domToPrettyText(dom);
				var code = f.javascript; //Blockly.JavaScript.workspaceToCode(Blockly.getMainWorkspace());
				blockly_history.push(xml, code);
			}
		}
    });
		

	//startMonitorChanges( blocklyEditor.getWorkspace() );
	
	var tbDivs = document.getElementsByClassName('blocklyToolboxDiv');
	if(tbDivs.length > 0)
	{   
		var toolboxDiv = tbDivs[0];
		
		// Add a shadow to the injected toolbox div
		toolboxDiv.style['box-shadow'] = 'rgba(0,0,0,0.75) 0px 0px 5px 0px';
		
		// // Add the hide button
		// toolboxDiv.insertAdjacentHTML( 'afterbegin', '<button id="hideToolboxButton">hide</button>' );
		
		// var showToolboxButton = document.getElementById('showToolboxButton');                
		// var hideToolboxButton = document.getElementById('hideToolboxButton');
		
		// showToolboxButton.addEventListener('click', function(e) {
		//         console.log("showToolboxButton");
		//         hideToolboxButton.display = 'inline-block';
		//         showToolboxButton.display = 'none';
		//         toolboxDiv.display = 'block';
		//     });
		
		// hideToolboxButton.addEventListener('click', function(e) {
		//         console.log("hideToolboxButton");
		//         hideToolboxButton.display = 'none';
		//         showToolboxButton.display = 'inline-block';
		//         toolboxDiv.display = 'none';
		//     });
	}
	
	// Bind to the global touchend event
	//onTouchEndWrapper = Blockly.bindEvent_(document, 'touchend', null, onTouchEnd);
	
	return blocklyEditor;
}

function blockly_loadXml( editor, xml, modify, readOnly )
{
	console.log( "blk: loadXml" )
	
	//Load the xml.
	editor.setEditorFile( xml );
	
	if( !readOnly )
	{
		//Sync blockly and ace.
		blockly_syncData( editor, modify );
		
		//Init undo history,
		var f = client.appService.getOpenApp().activeEditorFile;
		blockly_history.clear();
		blockly_history.push( xml, f.javascript );
	}
}

//Sync blockly and ace.
function blockly_syncData( editor, modify )
{
	console.log( "blk: synching blockly and ace" )
	 
	var dsApp = client.appService.getOpenApp();
	var f = dsApp.activeEditorFile;
	f.session.setValue( editor.getWorkspace() );
    f.workspace = editor.getWorkspace();
    f.javascript = editor.getJavaScript();
	setModified( f, modify );
	return f;
}

//Set current scroll pos.
function blockly_scroll( editor, scroll )
{
	console.log( "blk: scroll: " + scroll.x + "," + scroll.y )
	editor.workspace.scrollX = scroll.x
	editor.workspace.scrollY = scroll.y
}

//Get current scroll pos.
function blockly_getScroll( editor ) 
{ 
	console.log( "blk: getScroll: " + editor.workspace.scrollX + "," + editor.workspace.scrollY )
	return {  x:editor.workspace.scrollX, y:editor.workspace.scrollY }
}
 
function getURLParameter(name) 
{
	return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search)||[,""])[1].replace(/\+/g, '%20'))||null
}

//Create a read-only editor for samples.
function blockly_CreateSampleEditor() 
{
	console.log( "blockly_CreateSampleEditor" )
	var blocklyEditor = new BlocklyEditor;
    blocklyEditor.init(document.getElementById("sampleBlocklyEditor"), true);
	return blocklyEditor;
}


var id = -1;
var onTouchEndWrapper = null;

function dsj_Execute( p1 ) { prompt( "#", "App.Execute("+p1 ); }

function sendMessage(json)
{
	json.id = id;
	var data = JSON.stringify(json);
	dsj_Execute("_onBlocklyMessage( '" + data + "' )");
}

var blockly_history = 
{
	stack : [],
	index : -1,
	locked : false,
	push : function( xml, code ) {
		// Return without making changes if currently locked
		if(this.locked)
		{
			console.log("Can't push onto historyStack when locked");
			return;
		}
		
		if(this.index > -1)
		{
			var topStack = this.stack[this.index];
			// No changes
			if(xml == topStack.xml)
				return;
		}
		
		// If current index not end of stack - remove entries beyond index
		if(this.index != (this.stack.length - 1))
			this.stack = this.stack.slice(0, this.index + 1);
		
		this.stack.push( { xml: xml, code: code } );
		this.index = (this.stack.length - 1);
	},
	top : function() {
		if(this.index > -1)
			return this.stack[this.index];
		return null;
	},
	canUndo : function() {
		return (this.index > 0);
	},
	canRedo : function() {
		return (this.index < (this.stack.length-1));
	},
	undo : function() {
		if(this.canUndo())
			return this.stack[--this.index].xml;
		return null;
	},
	redo : function() {
		if(this.canRedo())
			return this.stack[++this.index].xml;
		return null;
	},
	clear : function() {
		this.stack = [];
		this.index = -1;
	}
};

/*
function blockly_onchange()
{
	console.log("onchange " + Blockly.dragMode_);
	
	// If currently dragging - ignore the change
	if(Blockly.dragMode_ != 0)
	{
		return;
	}
	
	Blockly.JavaScript.INFINITE_LOOP_TRAP = null;
	var dom = Blockly.Xml.workspaceToDom(Blockly.getMainWorkspace());
	var xml = Blockly.Xml.domToPrettyText(dom);
	var code = Blockly.JavaScript.workspaceToCode(Blockly.getMainWorkspace());
	
	//
	//sendMessage({
	//	msg: "onchange",
	//	xml: encodeURIComponent(xml),
	//	code: escape(code)
	//});
	
	// blockly_history is locked when performing Undo or Redo
	if(!blockly_history.locked)
	{
		blockly_history.push(dom, xml, code);
	}
}
*/

function onTouchEnd()
{
	console.log("onTouchEnd");
	// Not doing anything with this yet
}

function onhelp( blockType )
{
	console.log("onhelp " + blockType);

	sendMessage({
		msg: "onhelp",
		blockType: blockType
	});
}

/*
function setFile(blockId, file)
{
	var block = Blockly.Block.getById(blockId, Blockly.mainWorkspace);
	block.setFieldValue(file, "file");
}

function setCode(blockId, code)
{
	var block = Blockly.Block.getById(blockId, Blockly.mainWorkspace);
	block.setFieldValue(unescape(code), "code");
}
*/

function blockly_ShowError( editor, blockId )
{
	editor.workspace.highlightBlock( blockId, true );
	
	//.blocklySelected>.blocklyPath {", "  stroke: #fc3;", "  stroke-width: 3px;", "}"
}

/*
function startMonitorChanges( workspace, onchange )
{
	onchangeBindData = workspace.addChangeListener( onchange );
}

function stopMonitorChanges( workspace )
{
	workspace.removeChangeListener(onchangeBindData);
}

function blockly_loadWorkspace(editor, xml)
{
	xml = decodeURIComponent(xml);

	try
	{
		stopMonitorChanges( editor.getWorkspace() );
		
		// Dispose of the current workspace blocks
		//DS: Blockly.mainWorkspace.clear();
		editor.getWorkspace().clear();
		
		// Clear undo/redo history
		blockly_history.clear();
		
		// Wait for the load changes to take effect before starting to 
		// listen for workspace changes
		function loadChange() 
		{
			//DS: Blockly.mainWorkspace.removeChangeListener(loadBindData);
			editor.getWorkspace().removeChangeListener(loadBindData);
			blockly_onchange(); // Add initial historyStack entry and fire OnChangeCallback
			startMonitorChanges( editor.getWorkspace(), blockly_onchange );
		}
		//DS: var loadBindData = Blockly.mainWorkspace.addChangeListener(loadChange);
		var loadBindData = editor.getWorkspace().addChangeListener(loadChange);
		var dom = Blockly.Xml.textToDom( xml );
		//DS: Blockly.Xml.domToWorkspace( Blockly.mainWorkspace, dom );
		Blockly.Xml.domToWorkspace( editor.getWorkspace(), dom );
	}
	catch(e) {
		console.log("loadWorkspace Error:");
		console.log(e);
	}
}
*/

function blockly_undo( editor )
{
	var xml = blockly_history.undo();
	if(xml != null)
		doUndoRedo(editor,xml);
}

function blockly_redo( editor )
{   
	var xml = blockly_history.redo();
	if(xml != null)
		doUndoRedo(editor,xml);
}

function doUndoRedo( editor, xml )
{   
	// Lock the history stack until the undo/redo changes have been made.
	// This stops the undo/redo change from being added to the history.
	//blockly_history.locked = true;
	
	/*
	workspace.clear();
	
	// Wait for the undo/redo changes to take effect before starting to 
	// listen for workspace changes
	function undoRedoChange() {
		workspace.removeChangeListener(undoRedoBindData);
		// Unlock the history stack now the undo/redo change has been made
		blockly_history.locked = false;
	}                
	var undoRedoBindData = workspace.addChangeListener(undoRedoChange);
	*/
	
	//Blockly.Xml.domToWorkspace( workspace, undoRedoDom );
	editor.setEditorFile( xml ); 
	
	//Sync blockly and ace.
	blockly_syncData( editor, true );
}

function showToolbox()
{
	console.log("showToolbox");
	
	var tbDivs = document.getElementsByClassName('blocklyToolboxDiv');
	if(tbDivs.length > 0)
	{               
		var toolboxDiv = tbDivs[0];
		toolboxDiv.style.display = 'block';
		
		// Fire an event to allow scrollbars to resize.
		Blockly.fireUiEvent(window, 'resize');
	}
}

function hideToolbox()
{
	console.log("hideToolbox");
	
	var tbDivs = document.getElementsByClassName('blocklyToolboxDiv');
	if(tbDivs.length > 0)
	{   
		var toolboxDiv = tbDivs[0];
		toolboxDiv.style.display = 'none';
		
		// Fire an event to allow scrollbars to resize.
		Blockly.fireUiEvent(window, 'resize');
	}
}

function shrinkToolbox()
{
	console.log("shrinkToolbox");
	
	var tbDivs = document.getElementsByClassName('blocklyToolboxDiv');
	if(tbDivs.length > 0)
	{   
		var toolboxDiv = tbDivs[0];
		toolboxDiv.style.width = "20px";
		
		// Fire an event to allow scrollbars to resize.
		Blockly.fireUiEvent(window, 'resize');
	}
}

function isToolboxVisible()
{
	var tbDivs = document.getElementsByClassName('blocklyToolboxDiv');
	if(tbDivs.length > 0)
	{   
		console.log("isToolboxVisible");
		
		var toolboxDiv = tbDivs[0];
		return (toolboxDiv.style.display != 'none');
	}
	
	return false;
}

function setClipboardXml(xml)
{
	console.log(decodeURIComponent(xml));
	
	var xmlDom = Blockly.Xml.textToDom(decodeURIComponent(xml));
	Blockly.clipboardXml_ = xmlDom;
	Blockly.clipboardSource_ = Blockly.mainWorkspace;
}

function paste()
{
	if(Blockly.clipboardXml_) 
	{
		var xml = Blockly.clipboardXml_;
		
		var childCount = xml.childNodes.length;
		for(var i = 0; i < childCount; i++) 
		{
			var xmlChild = xml.childNodes[i];
			if(xmlChild.nodeName.toLowerCase() == 'block') 
			{
				Blockly.mainWorkspace.paste(xmlChild);
			}
		}
		
		// Blocks may have been pasted from read-only workspace
		// so make sure they are now editable
		var allBlocks = Blockly.mainWorkspace.getAllBlocks();
		for(var i = 0; i < allBlocks.length; ++i)
		{
			var block = allBlocks[i];
			block.setDeletable(true);
			block.setMovable(true);
			block.setEditable(true);
		}
	}
}



//------- Blockly wrapper object-------------

function BlocklyEditor() 
{
	this.initialised = !1;
	this.onChangeFunc = null;
	this.onChangeBindData = null;
	this.domElement = null;
	this.readOnly = !1;
	this.workspace = null
}	
	

BlocklyEditor.prototype.init = function(n, t) {
    this.initialised || (this.domElement = n,
    this.readOnly = t,
    console.log("Blockly init"),
    this.workspace = Blockly.inject(n, {
        toolbox: document.getElementById("toolbox"),
        readOnly: t,
        scrollbars: !0,
        media: "dsj/blockly/media/",
        comments: !1,
        disable: !1,
        zoom: {
            enabled: !0
        }
    }),
    Blockly.JavaScript.finish = function(n) {
        var r = Blockly.JavaScript.definitions_.variables
          , t = [];
        for (var i in Blockly.JavaScript.definitions_)
            i != "variables" && t.push(Blockly.JavaScript.definitions_[i]);
        //return 'app.LoadScript("/sdcard/DroidScriptJr/DSJExtras.js");\n\n' + r + "\n\n" + n + "\n" + t.join("\n\n")
		return r + "\n\n" + n + "\n" + t.join("\n\n")
    }
    ,
    this.initialised = !0)
}

BlocklyEditor.prototype.setEditorFile = function( xml ) {
    function u() {
        t.workspace.removeChangeListener(r);
        t.onChangeFunc != null && t.addChangeListener(t.onChangeFunc)
    }
    var i, t, r;
    this.onChangeBindData != null && (this.workspace.removeChangeListener(this.onChangeBindData),
		console.log("removeChangeListener"));
    i = decodeURIComponent(xml);
    t = this;
    r = this.workspace.addChangeListener(u);
	
    this.loadWorkspace(i)
}

//Load the blockly XML to workspace.
BlocklyEditor.prototype.loadWorkspace = function(n) {
    try {
		//alert( n )
        this.workspace.clear();
        var t = Blockly.Xml.textToDom(n);
        Blockly.Xml.domToWorkspace(this.workspace, t)
    } catch (i) {
        console.log("BlocklyEditor.loadWorkspace Error:");
        console.log(i)
    }
}

BlocklyEditor.prototype.getWorkspace = function() {
    try {
        var n = Blockly.Xml.workspaceToDom(this.workspace);
        return Blockly.Xml.domToPrettyText(n)
    } catch (t) {
        console.log("BlocklyEditor.getWorkspace Error:");
        console.log(t)
    }
    return null
}

BlocklyEditor.prototype.getJavaScript = function() {
    try {
        Blockly.JavaScript.INFINITE_LOOP_TRAP = null;
        return Blockly.JavaScript.workspaceToCode(this.workspace)
    } catch (n) {
        console.log("BlocklyEditor.getJavaScript Error:");
        console.log(n)
    }
    return null
}

BlocklyEditor.prototype.setFocus = function() {}

BlocklyEditor.prototype.show = function() {
    $(this.domElement).show();
    this.readOnly || ($(".blocklyToolboxDiv").show(),
    $("#jsButton").show())
}

BlocklyEditor.prototype.hide = function() {
    Blockly.hideChaff();
    $(this.domElement).hide();
    this.readOnly || ($(".blocklyToolboxDiv").hide(),
    $("#jsButton").hide())
}

BlocklyEditor.prototype.resize = function() {
    Blockly.svgResize(this.workspace)
}

BlocklyEditor.prototype.addChangeListener = function(n) {
    console.log("addChangeListener");
    this.onChangeFunc = n;
    this.onChangeBindData = this.workspace.addChangeListener(n)
}

BlocklyEditor.prototype.collapseAll = function() {
    for (var n, i = this.workspace.getTopBlocks(!1), r = 0, t = 0; t < i.length; t++)
        for (n = i[t]; n; )
            setTimeout(n.setCollapsed.bind(n, !0), r),
            n = n.getNextBlock(),
            r += 10
}

BlocklyEditor.prototype.expandAll = function() {
    for (var n, i = this.workspace.getTopBlocks(!1), r = 0, t = 0; t < i.length; t++)
        for (n = i[t]; n; )
            setTimeout(n.setCollapsed.bind(n, !1), r),
            n = n.getNextBlock(),
            r += 10
}

//Colours for DS blocks.
var ds_options_hue = 43;
var ds_game_hue = "#6AA326"; //"#0E9B43";
var ds_comment_hue = "#888888";
var ds_code_hue = "#555555";
var ds_callback_hue = 210;


//---- Blockly overrides ------------------------------------


//Override colours (make similar to micro:bit scheme)
Blockly.HSV_SATURATION = .7; //.45;
Blockly.HSV_VALUE = .80 //.65;
Blockly.Blocks.variables.HUE = 348; //330;
Blockly.Blocks.texts.HUE = 43; //160;
Blockly.Blocks.math.HUE = 282; //230;
Blockly.Blocks.logic.HUE = 181; //210;
Blockly.Blocks.procedures.HUE = 228; //290;
Blockly.Blocks.lists.HUE = 16; //260;

//Override toolbox indent with.
goog.ui.tree.BaseNode.prototype.getPixelIndent_ = function() {
    return Math.max(0, (this.getDepth() - 1) * 10); //this.config_.indentWidth)
}

//Override maximum length of text to display before adding an ellipsis.
Blockly.Field.prototype.maxDisplayLength = 30;

//Override default zoom scale.
Blockly.WorkspaceSvg.prototype.scale = 0.95;

//Override the default zoom.
Blockly.WorkspaceSvg.prototype.zoomReset = function() {
    this.scale = Blockly.WorkspaceSvg.prototype.scale;
    this.updateGridPattern_();
    var a = this.getMetrics();
    this.scrollbar.set((a.contentWidth - a.viewWidth) / 2, (a.contentHeight - a.viewHeight) / 2)
}

// Override the default show help functionality
Blockly.BlockSvg.prototype.showHelp_ = function() {
	//todo: onhelp(this.type);
};

//Override blockly hightlighting to support errors (in red).
Blockly.Css.CONTENT.push( ".blocklyError>.blocklyPath { stroke: #f00;  stroke-width: 5px;}" );

Blockly.WorkspaceSvg.prototype.highlightBlock = function( id, error ) 
{
	var b = this.getBlockById( id )
	if( b ) b.select( error )
}
Blockly.BlockSvg.prototype.select = function( error ) {
    Blockly.selected && Blockly.selected.unselect();
    Blockly.selected = this;
    this.addSelect( error );
    Blockly.fireUiEvent(this.workspace.getCanvas(), "blocklySelectChange")
}
Blockly.BlockSvg.prototype.removeSelect = function() {
    Blockly.removeClass_(this.svgGroup_, "blocklySelected")
	Blockly.removeClass_(this.svgGroup_, "blocklyError")
}
Blockly.BlockSvg.prototype.addSelect = function( error ) {
	Blockly.addClass_(this.svgGroup_,"blocklySelected");
	if( error ) Blockly.addClass_(this.svgGroup_,"blocklyError");
    this.svgGroup_.parentNode.appendChild(this.svgGroup_)
}

// Override the JavaScript generator finish method to define the order
// of the code:
// - app.LoadScript("/sdcard/DroidScriptJr/DSJExtras.js");
// - variables
// - code
// - functions
Blockly.JavaScript.finish = function(code) {
	var loadScript = 'app.LoadScript("/sdcard/DroidScriptJr/DSJExtras.js");';
	var variables = Blockly.JavaScript.definitions_['variables'];
	
	// Convert the functions from the definitions dictionary into a list.
	var functions = [];
	for(var name in Blockly.JavaScript.definitions_)
	{
		if(name != 'variables') // Skip variables definition code
		{                    
			functions.push(Blockly.JavaScript.definitions_[name]);
		}
	}
  
	return loadScript + '\n\n' + variables + '\n\n' + code + '\n' + functions.join('\n\n');
};

Blockly.FieldColour.prototype.showEditor_ = function() {
	try
	{
		var colPickerHtml = '<div id="colorPicker">';
		colPickerHtml += '<a class="color"><div class="colorInner"></div></a>';
		colPickerHtml += '<div class="track"></div>';
		colPickerHtml += '<ul class="dropdown"><li></li></ul>';
		colPickerHtml += '<input type="hidden" class="colorInput"/>';
		colPickerHtml += '</div>';
		
		var colPickerElement = $(colPickerHtml);   
		colPickerElement.tinycolorpicker({ backgroundUrl: "tinycolorpicker/images/text-color.png" });
		
		var picker = colPickerElement.data("plugin_tinycolorpicker");
		picker.setColor(this.getValue());
		picker.toggle();
	
		function pickerDispose()
		{
			colPickerElement.unbind("change");
			colPickerElement.remove();
		}

		Blockly.WidgetDiv.show(this, this.sourceBlock_.RTL, pickerDispose);
	
		// Position the palette to line up with the field.
		// Record windowSize and scrollOffset before adding the palette.
		var windowSize = goog.dom.getViewportSize();
		var scrollOffset = goog.style.getViewportPageOffset(document);
		var xy = this.getAbsoluteXY_();
		var borderBBox = this.borderRect_.getBBox();
		var div = Blockly.WidgetDiv.DIV;
	
		$(div).append(colPickerElement);
		
		var paletteSize = {
			width: colPickerElement.outerWidth(true),
			height: colPickerElement.outerHeight(true)
		};

		var centreX = xy.x + (borderBBox.width / 2);
		var centreY = xy.y + (borderBBox.height / 2);
		
		xy.x = centreX - (paletteSize.width / 2);
		xy.y = centreY - (paletteSize.height / 2);        
		
		Blockly.WidgetDiv.position(xy.x, xy.y, windowSize, scrollOffset, this.sourceBlock_.RTL);

		// Configure event handler.
		var thisField = this;
		colPickerElement.bind("change", function() {
			var box = colPickerElement.data("plugin_tinycolorpicker");
			
			var colour = box.colorHex;
			
			if (thisField.sourceBlock_ && thisField.changeHandler_) 
			{
				// Call any change handler, and allow it to override.
				var override = thisField.changeHandler_(colour);
				if (override !== undefined) 
				{
					colour = override;
				}
			}
			if (colour !== null) 
			{
				thisField.setValue(colour);
			}
			//Blockly.WidgetDiv.hide();
		});
	}
	catch(e)
	{
		alert(e);
	}
};

Blockly.ContextMenu.show = function(e, options, rtl) {

	console.log("ContextMenu.show");
	
	// Show the Paste option if the user has shown the ContextMenu
	// by long pressing in the workspace (not on a block)
	var isWorkspaceContextMenu = (Blockly.selected == null);            
	if(isWorkspaceContextMenu && Blockly.clipboardXml_)
	{
		var pasteOption = {
				text: 'PASTE',
				enabled: true,
				callback: paste
			};
			
		options.push(pasteOption);
	}
	
	var menu = new TouchMenu(e.clientX, e.clientY, options, rtl);
	menu.show();
};

Blockly.FieldTextInput.prototype.showImageBrowser = function() {
	sendMessage({
		msg: "browseimage",
		blockId: this.sourceBlock_.id,
		callback: "setFile"
	});
};

Blockly.FieldTextInput.prototype.showSoundBrowser = function() {
	sendMessage({
		msg: "browsesound",
		blockId: this.sourceBlock_.id,
		callback: "setFile"
	});
};

Blockly.FieldTextInput.prototype.showCodeEditor = function() {
	sendMessage({
		msg: "editcode",
		blockId: this.sourceBlock_.id,
		code: escape(this.sourceBlock_.getFieldValue("code")),
		callback: "setCode"
	});
};

//Add our func to allow full hex colours.
Blockly.makeColour = function(a) {
	if( typeof a == "string" && a.indexOf("#")>-1 ) return goog.color.normalizeHex(a);
    else return goog.color.hsvToHex(a, Blockly.HSV_SATURATION, 255 * Blockly.HSV_VALUE)
}

//Override toolbox text handler to allow html tags.
Blockly.Toolbox.TreeControl.prototype.createNode = function(a) {
	var config = this.getConfig();
	//config.indentWidth = 0; ***no work
    return new Blockly.Toolbox.TreeNode(this.toolbox_,a ? /*goog.html.SafeHtml.htmlEscape(a)*/a : goog.html.SafeHtml.EMPTY,config,this.getDomHelper())
}

//Override blockly toolbox to allow text colours.
Blockly.Toolbox.prototype.populate_ = function(a) {
    function b(a, e) {
        for (var f = 0, g; g = a.childNodes[f]; f++)
            if (g.tagName)
                switch (g.tagName.toUpperCase()) {
                case "CATEGORY":
					var n = g.getAttribute("name");
					var x = g.getAttribute("colour"); 
					if( x ) n = "<font color="+Blockly.makeColour(x)+">"+ n + "</font>";
					
                    var h = c.createNode(n);
                    h.blocks = [];
                    e.add(h);
                    var k = g.getAttribute("custom");
                    k ? h.blocks = k : b(g, h);
                    "true" == g.getAttribute("expanded") && (h.blocks.length && c.setSelectedItem(h),
                    h.setExpanded(!0));
                    break;
                case "SEP":
                    e.add(new Blockly.Toolbox.TreeSeparator);
                    break;
                case "BLOCK":
                    e.blocks.push(g)
                }
    }
    var c = this.tree_;
    c.removeChildren();
    c.blocks = [];
    b(a, this.tree_);
    if (c.blocks.length)
        throw "Toolbox cannot have both blocks and categories in the root level.";
    Blockly.fireUiEvent(window, "resize")
}

/* delete me
Blockly.Generator.prototype.prefixLines = function(a, b, blk) {
	//b = blk.id+ + b; //Add block id.
    return b + a.replace(/\n(.)/g, "\n" + b + "$1")
}
Blockly.Generator.prototype.statementToCode = function(a, b) {
    var c = a.getInputTargetBlock(b)
      , d = this.blockToCode(c);
    goog.asserts.assertString(d, 'Expecting code from statement block "%s".', c && c.type);
    d && (d = this.prefixLines(d, this.INDENT, a));
    return d
}
*/

//Override code generator to add line numbers.
Blockly.Generator.prototype.blockToCode = function(a) {
    if (!a)
        return "";
    if (a.disabled)
        return this.blockToCode(a.getNextBlock());
    var b = this[a.type];
    goog.asserts.assertFunction(b, 'Language "%s" does not know how to generate code for block type "%s".', this.name_, a.type);
    b = b.call(a, a);
	
	//Write block id to code as comment prefix.
	Blockly.JavaScript.STATEMENT_PREFIX = "/*%1*/ ";
	
    if (goog.isArray(b))
        return [this.scrub_(a, b[0]), b[1]];
    if (goog.isString(b))
        //return this.STATEMENT_PREFIX && (b = this.STATEMENT_PREFIX.replace(/%1/g, "'" + a.id + "'") + b),
		return this.STATEMENT_PREFIX && (b = this.STATEMENT_PREFIX.replace(/%1/g, a.id) + b),
        this.scrub_(a, b);
    if (null === b)
        return "";
    goog.asserts.fail("Invalid code generated: %s", b)
}

//Override value extractor to make sure we at least get a null rather than an empty string.
//(or we can have cryptic errors that are hard for user to find)
Blockly.Generator.prototype.valueToCode = function(a, b, c) {
    isNaN(c) && goog.asserts.fail('Expecting valid order from block "%s".', a.type);
    a = a.getInputTargetBlock(b);
    if (!a)
        return null; //return "";
    var d = this.blockToCode(a);
    if ("" === d)
        return null; //return "";
    goog.asserts.assertArray(d, 'Expecting tuple from value block "%s".', a.type);
    b = d[0];
    d = d[1];
    isNaN(d) && goog.asserts.fail('Expecting valid order from value block "%s".', a.type);
    b && c <= d && (c != d || 0 != c && 99 != c) && (b = "(" + b + ")");
	
    return b
}

