
//Globals.
var gfx = new Gfx();
var cfg = {Game:0, Landscape:0, Portrait:0, NoDom:0, Transparent:0 }

function Gfx()
{
    //--- Public properties -------------------
	
	//#User data
	this.data = {} 
	
    this.width = _ww = window.innerWidth;
    this.height = _wh = window.innerHeight;
    this.aspect = _asp = this.width / this.height;
	
	//#List of graphical objects.
	this.objects = [];
	
	//#Currently pressed key.
	this.keyDown = null;  
	
	//#Current key state.
	this.keyState = null; 
	
	this.touchX, this.touchY, this.touchDir;
	this.isReady = false;
	
	//--- Public methods------------------------
	
    //#Loads and execute an external script.
    this.Script = function( url, callback ) { }
	
	//#Execute code in the main DS app.
    this.AppExec = function( js ) { }
	
	//#Hardware calls
    this.Vibrate = function( pattern ) { }
    
	this.Play = function() {}
	this.Pause = function() {}
	
	this.AddPhysics = function( gravity, accuracy, sleep ) {}
	
	this.EnablePhysics = function( enabled ) { _phys.SetEnabled( enabled ) }
	this.SetOnCollide = function( callback ) { _phys.SetOnCollide( callback ) }
	
	//#Enclose an area with a physics fence.
	this.Enclose = function( groupId, options, density, bounce, friction, offset ) { }
	
    this.SetBackColor = function( col ) {  }
    
	//#Create a sprite in memory
    this.CreateSprite = function( file, group, callback )  { return new Sprite(); }
    
	//#Create a sprite sheet in memory
	this.CreateSpriteSheet = function( file, callback ) { }
	
    //#Add sprite to scene,
    this.AddSprite = function( sprite, x, y, w, h, angle, alpha ) { }
	
	//#Remove a sprite from the scene.
	this.RemoveSprite = function( sprite ) { }
	
	//#Create a background tiled and moveable.
	//#(image should be tileable in both directions)
	this.CreateBackground = function( file, options ) { }
	
	//#Add background to screen.
	this.AddBackground = function( tiles ) { }
	
	//#Todo:
    this.CreateRectangle = function( width, height, color, lineWidth, lineColor, lineAlpha, group ) {  }
	
	this.CreateEllipse = function( width, height, color, lineWidth, lineColor, lineAlpha, group ) { }
	
	this.CreateCircle = function( width, color, lineWidth, lineColor, lineAlpha ) { }
	
	//#Create a polygon shape.
	//#Note: Physics not currently supported on polygons.
	this.CreatePolygon = function( points, pivotX, pivotY, color, lineWidth, lineColor, lineAlpha, group ) { }
	
    //#Add an object to the canvas.
    this.AddGraphic = function( obj, x, y, w, h, angle, alpha ) { }
    
    //#Create a batch container for super fast group rendering.
    this.CreateBatch = function() { }
    
    //#Add the batch to the scene.
    this.AddBatch = function( batch ) { }
    
    //#Support simple/basic sprite objects (lighter and faster).
    this.AddBasicSprite = function( sprite ) {  }
	this.CreateBasicSprite = function( texture ) {  }
	
	//#z order methods.
	this.GetOrder = function( object ) {  }
	this.SetOrder = function( object, order ) { }
	this.SwapOrder = function( object1, object2 ) { }
	
    this.CreateTexture = function( file ) { }
	
    this.IsHit = function( obj1, obj2, depth ) { }
    
    //#Set callback for touch down.
	this.SetOnTouchDown = function( callback ) { _onTouchDown = callback }
	
	//#Set callback for touch move.
	this.SetOnTouchMove = function( callback ) 	{ }
	
	//#Set callback for touch up.
	this.SetOnTouchUp = function( callback ) { }
	
	//#Set callbacks for key up/down.
	this.SetOnKeyDown = function( callback ) {  }
	this.SetOnKeyUp = function( callback ) {  }
	
    this.CreateSound = function( file ) { return new Sound( id, file ) }
}

//#Sound object.
function Sound( id, file )
{
	this.id = id
	this.file = file
	this.Play = function( loop, delay, gap ) { 	}
	this.Pause = function() { }
}

//#Background object.
function Background()
{
	this.Scroll = function( x, y ) { }
}

//#Rectangle object.
function Rectangle()
{
	this.width = 0, this.height = 0;
	this.angle = 0, this.alpha = 1;
	this.pivotX = 0.5, this.pivotY = 0.5;  
	this.scaleX=1, this.scaleY=1;
	
	this.Update = function() {}
	this.SetMatrix = function( mtx ) { }
	this.Contains = function( x, y ) { }
}

//#Ellipse object.
function Ellipse()
{
	this.width = 0, this.height = 0;
	this.angle = 0, this.alpha = 1;
	this.pivotX = 0.5, this.pivotY = 0.5;  
	this.scaleX=1, this.scaleY=1;
	
	this.Update = function() {}
	this.SetMatrix = function( mtx ) { }
	this.Contains = function( x, y ) { }
}

//#Circle object.
function Circle()
{
	this.width = 0, this.height = 0;
	this.angle = 0, this.alpha = 1;
	this.pivotX = 0.5, this.pivotY = 0.5;  
	this.scaleX=1, this.scaleY=1;
	
	this.Update = function() {}
	this.SetMatrix = function( mtx ) { }
	this.Contains = function( x, y ) { }
}

//#Polygon object.
function Polygon()
{
	this.width = 0, this.height = 0;
	this.angle = 0, this.alpha = 1;
	this.pivotX = 0.5, this.pivotY = 0.5;  
	this.scaleX=1, this.scaleY=1;
	
	this.Update = function() {}
	this.SetMatrix = function( mtx ) { }
	this.Contains = function( x, y ) { }
}

//#Sprite object.
function Sprite()
{
	var _this = this; this.visible=true; this.added = false;
	this.x=0,this.y=0,this.width=0,this.height=0,this.alpha=1,this.sprite=null;
	this.angle=0,this.pivotX=0.5,this.pivotY=0.5;
	this.scaleX=1,this.scaleY=1; this.aspect=1;
			
	this.Update = function() { }
	this.SetSize = function( w, h ) { }
	this.SetTexture = function( tx ) {  }
	this.SetTween = function(  ) { 	}
	this.Tween = function( target,duration,type,repeat,yoyo,callback ) { }
	
	this.SetPlaySpeed = function( speed ) { }
	this.SetLoop = function( loop ) { }
	this.Goto = function( frame ) {  }
	this.Stop = function() {  }
	this.StopAt = function( frame ) {  }
	this.SetRange = function( firstFrame, lastFrame, loop, play, speed ) {  }
	this.PlayRange = function( firstFrame, lastFrame, speed, loop ) {  }
	this.PlayTo = function( frame ) {  }
	
	this.Play = function( startFrame, speed, loop ) { }
	this.SetSpriteSheet = function( sheet ) { }
	
	//#Set fixture shape (currently only a single fixture supported)
	this.SetShape = function( shape, width, height ) { }
	
	//#Add 'SetVelocity' property to source object.
	this.SetVelocity = function( x, y, angular, bodyRelative ) {	}
	
	//#Add 'AddVelocity' property to source object.
	this.AddVelocity = function( x, y, angular, bodyRelative ) {	}
	
	//#Get the velocity of the object ( "x", "y", "angular", null)
	this.GetVelocity = function( component ) { }
	
	//#Add 'ApplyImpulse' property to source object.
	//# dx, dy are offsets from object center (range -1 to +1)
	this.ApplyImpulse = function( x, y, offsetX, offsetY ) { }
	
	//#Add 'Update' property to source object.
	this.UpdatePhysics = function() { }
	
	//#Disable or enable physics for this object.
	this.EnablePhysics = function( enable ) { }
	this.RemovePhysics = function() { }
	
	this.StepTween = function() { }
	this.PlayTween = function(){ }
	this.PauseTween = function(){ }
	this.StartTween = function() { }
}
	

