
//Called when application is started.
function OnStart()
{
	//Create a layout with objects vertically centered.
	lay = app.CreateLayout( "Linear", "FillXY" );	
	
	//Create a blank image.
	img = app.CreateImage( null, 0.8, 0.8 );
	lay.AddChild( img );

	//Add layout to app.	
	app.AddLayout( lay );
	
	//Draw our picture.
	DrawPicture();
}

function DrawPicture()
{
	//Fill image with solid white.
	img.SetColor( "#ffffffff" );
	
	//Set drawing color to blue
	//format is (#alpha:red:green:blue) in hex.
	img.SetPaintColor( "#ff0000ff"  );
	
	//Draw a tiny point (single pixel) in
	//the center of the image.
	img.DrawPoint( 0.5, 0.5 );
		
	//Draw diagonal line.
	img.SetLineWidth( 2.5 );
	img.SetPaintColor( "#ff0000ee"  );
	img.DrawLine( 0.6, 0.2, 0.7, 0.95 );
	
	//Draw circle with radius 0.1 of image width.
	img.SetPaintColor( "#ff992299"  );
	img.DrawCircle( 0.2, 0.2, 0.1 );

	//Draw some red text.
	img.SetTextSize( 24 );
	img.SetPaintColor( "#ffff0000"  );
	img.DrawText( "Hello World", 0.1, 0.8 );
	
	//Draw translucent rectangle.
	img.SetPaintColor( "#22444444"  );
	img.DrawRectangle( 0.22, 0.7, 0.9, 0.88 );
	
	//Draw un-filled circle.
	img.SetPaintStyle( "Line" );
	img.SetPaintColor( "#ff00aa00" );
	img.DrawCircle( 0.3, 0.5, 0.05 );
}
