//Simple example of using a Joystick or Gamepad.
//(Works with Xbox 360 game pad via OTG cable and 
//probably works with other USB HID devices too).

//Called when application is started.
function OnStart()
{
	//Create a layout with objects vertically centered.
	lay = app.CreateLayout( "linear", "VCenter,FillXY" );	

	//Create a text control to show data log.
	txt = app.CreateText( "", 1.0, null, "MultiLine" );
	txt.SetTextColor( "#ffffffff" );
	txt.SetTextSize( 22 );
	lay.AddChild( txt );
	
	//Add layout to app.	
	app.AddLayout( lay );
	
	//Enabling the 'ForwardKeys' option will allow users
	//to navigate your App using the d-pad, X and B key.
	//app.SetJoystickOptions( "ForwardKeys" );
	
	//Start timer to show joystick state.
	setInterval( ShowState, 200 );
}

//Called 5x as second.
function ShowState()
{
    //Get the first connected joystick's name.
    //(only available after joystick is used)
    var name = app.GetJoystickName( 0 );
    
    //Get state of various keys.
    var up = app.GetJoystickState( 0, "A" );
    var left = app.GetJoystickState( 0, "B" );
    
    //Get state of first 2 axis.
    var xaxis = app.GetJoystickState( 0, "axis-0" );
    var yaxis = app.GetJoystickState( 0, "axis-1" );
    
    //Show state.
    var msg = name + "\n";
    msg += "A:" + up + " B:" + left + "\n";
    msg += " X:" + xaxis.toFixed(2) + " Y:" + yaxis.toFixed(2); 
	txt.SetText( msg );
}
