
//Called when application is started.
function OnStart()
{
	//Create a layout with objects vertically centered.
	lay = app.CreateLayout( "linear", "VCenter,FillXY" );	
 
	//Create a button.
	btn = app.CreateButton( "Write to external sdcard" );
	btn.SetOnTouch( btn_OnTouch );
	btn.SetMargins( 0, 0.05, 0, 0 );
	lay.AddChild( btn );
	
	//Add layout to app.	
	app.AddLayout( lay );
}

//Called when user touches our button.
function btn_OnTouch()
{
    WriteToCard();
}

//Write a file to the external card.
function WriteToCard()
{
    if( !app.CheckPermission( "extsdcard" ) )
    {
        alert( "Please give permission to access your external sdcard by"
    	        + " selecting the top level folder" );
    	app.GetPermission( "extsdcard", OnPermission );
    	return;
    }
    
    app.MakeFolder( "/extsdcard/testfolder" );
    app.WriteFile( "/extsdcard/testfolder/test.txt", "Hello" );
    
    var s = app.ReadFile( "/extsdcard/testfolder/test.txt" );
    app.ShowPopup( s + " successfully written!" );
}

//Handle result of permission request.
function OnPermission( result )
{
    if( !result ) 
        app.ShowPopup( "Permission not granted!" );
    else
        WriteToCard();
}
