//This WiFi messaging sample broadcasts UDP network
//messages to every device inside your WiFi network (that
//is running this sample).  This sample could easily be
//extended to create a WiFi-Chat Application or used as
//starting point for a multi-player Wifi game.
//(Note: A few routers block fast UDP messages by default)

//Called when application is started.
function OnStart()
{
	//Create a layout with objects vertically centered.
	lay = app.CreateLayout( "linear", "VCenter,FillXY" );	

	//Create a button.
	btn = app.CreateButton( "Send", 0.3, 0.1 );
	btn.SetMargins( 0, 0.05, 0, 0 );
	lay.AddChild( btn );
	btn.SetOnTouch( btn_OnTouch );
	
	//Add layout to app.	
	app.AddLayout( lay );
	
	//Create UDP network object.
	net = app.CreateNetClient( "UDP" );
	
	//Get the UDP broadcast address and set our port number.
	address = net.GetBroadcastAddress();
	port = 19700;
	
	//Get our device id.
	id = app.GetDeviceId();
	
	//Start timer to check for incoming messages.
	setInterval( CheckForMsg, 200 );
}

//Called when user touches our button.
function btn_OnTouch()
{
    //Broadcast our Datagram (UDP) packet.
    var msg = "Hello";
    var packet = id + "|" + msg;
	net.SendDatagram( packet, "UTF-8", address, port );
}

//Called by our interval timer.
function CheckForMsg()
{
    //Try to read a packet for 1 millisec.
	var packet = net.ReceiveDatagram( "UTF-8", port, 1 );
	if( packet ) 
	{ 
	    //Extract original parts.
	    parts = packet.split("|");
	    var id = parts[0];
	    var msg = parts[1]; 
	   
	    //Show the message if not sent by this device.
	    if( id != id )
		    app.ShowPopup( msg);
	}
}


